#!/usr/local/bin/perl
#
$host=shift;
$ThisHost=`uname -n`;
chomp $ThisHost;

$lt=time;
# start from topitall directory
chdir  "../..";

$lt=time;

$F="server/Connect/Connect.$host";

unless ($mtime=(stat("$F"))[9]) {
  print "<p>Host File $F Not Found</p>\n";
  exit;
  }
# Give the server 2 seconds grace 
  $updateFreq=`cat $F` * 60 + 2;
  if ($lt-$mtime > $updateFreq) { $Border{$host}='#FFFFFF'; } #White 
  else {$Border{$host}='#009900'; }#green
  $crap=$lt-$mtime;
#  print "<p>$crap $updateFreq $host $Cat1 $Cat2 $lt $mtime $Border{$host}</p>\n";
 
 $mtime=0;
 $AF="server/Alert/Alert.$host";
  if ($mtime=(stat("$AF"))[9]) {
#  print "<p>$AF mtime $mtime</p>\n";
  $crap=$lt-$mtime;
  if ($lt-$mtime <= ($updateFreq*5)) { $Border{$host}='#FFCC55'; } # yellow
  if ($lt-$mtime <= ($updateFreq*2)) { $Border{$host}='#FF9999'; } # pink
  if ($lt-$mtime <= $updateFreq) { $Border{$host}='#FF0000'; } # red
  }
#  print "<p>$crap $updateFreq $host $lt $mtime $Border{$host}</p>\n";


print <<EOF
Content-type: text/html


<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" content="text/html; charset=iso-8859-1">
<META HTTP-EQUIV="expires" content="0">
<META HTTP-EQUIV="pragma" content="no-cache">
<META NAME="DESCRIPTION" CONTENT="Topitall Host">
<TITLE>Topitall Host $host</TITLE>


<h2>Topitall : $host</h2>
<table BORDER CELLSPACING=0 CELLPADDING=2 HEIGHT="20" BGCOLOR="#FFFF99" >

EOF
;

# print host button first
print "<tr><td ALIGN=CENTER BGCOLOR=\"$Border{$host}\">$host</td><tr>\n<tr>\n";

@AFile=`cat server/Alert/Alert.$host`;
 chomp @AFile;
 if (scalar @AFile < 1) { $AFile[0]="-1 Alert $host #No Alerts for this host";}
 foreach $Alert (@AFile) { 
   ($crap,$comment)=split('#',$Alert);
   ($t,$crap,$mhost,$freq,$cat1,$cat2,$cat3,$email)=split(' ',$crap);
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($t); 
   $month=(qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec))[$mon];
   $myear=$year+1900;
   if ($t<0) {$myear="____"; $month="___"; $mday="__"; $hour="__"; $min="__";}
   # Truncate the comment to 80 chars so it looks tidy
   $mcomment=substr($comment,0,80);

#  Is this alert recent 
    if ($cat1 eq "System")  {$Acat=$cat2} #Red
    else { $Acat= "$cat1 $cat2";}
   $crap=$lt-$t;
   # Construct a category string to match the box and find the colour
   $Border{$Acat}='#FFFF99';  # yellow
   if ($crap <= ($updateFreq*5)) { $Border{$Acat}='#FFCC55'; } # pink
   if ($crap <= ($updateFreq*2)) { $Border{$Acat}='#FF9999'; } # pink
   if ($crap <= $updateFreq) { $Border{$Acat}='#FF0000'; } # red
#   print "<p>$crap $updateFreq $cat1 $cat2 $Acat $Border{$Acat}</p>\n";
   print "<tr><td BGCOLOR=\"$Border{$Acat}\">$myear $month $mday $hour:$min</td>\n";
   print "<td>$mhost $freq $cat1 $cat2 $cat3</td>\n";
   print "<td>$email</td>\n";
   print "<td>$mcomment</td><tr>\n";
#   print "<tr><td>$Alert</td><tr>\n";
   }
# Construct a category string to match the box and find the colour

print "</tr>\n</table>\n";
print "<br><table BORDER CELLSPACING=0 HEIGHT=20 BGCOLOR=\"#009900\"><tr>";
 
#Find out if we are a client as well as server
$Cmtime=(stat('tia/plot.cfg'))[9];
# Has the topitall client run in the last 24 hours ?
if (($lt-$Cmtime < 86400) && ($ThisHost eq $host))  { chdir 'tia'; $Rpath='tia';} #We are client & server 
else { chdir 'server/RRD'; $Rpath='server/RRD';} # We are server only

@Files=`ls $host.*.rrd`;
chomp @Files;
$NButton=-1;
foreach $F (@Files) {
  $NButton++;
  if ($NButton>= 7) {
    print "</tr>\n<tr>\n";
    $NButton=0;
  }
  ($host,$Cat1,$Cat2,$Cat3)=split('\.',$F);
  if ($Cat3 eq "rrd") { $Category="$Cat1 $Cat2" ;}
  if ($Cat2 eq "rrd") { $Category=$Cat1 ; }
#  print "<p>$Category $Border{$Category}</p>";
  if (defined $Border{$Category}) {
    $Color=$Border{$Category}; }
  else 
  {$Color="#009900"; }

  print "<td WIDTH=100 ALIGN=CENTER BGCOLOR=\"$Color\"><A HREF=\'/tia/tgraph.cgi?-rrd%20$Rpath/$F\'> $Category </A></td>\n";
 }
print "</tr></table>\n";
print <<EOF
<br>
<table BORDER CELLSPACING=0 HEIGHT="20" BGCOLOR="#FFCC55" >
<tr>
<td><A HREF=\"/tia/host.cgi?$host\">$host</A></td>
<td><A HREF=\"/tia/monitor.cgi\">Monitor</A></td>
</tr>
</table>
EOF
;
 
print "</body>\n</html>\n";
