#!/usr/local/bin/perl
#
use lib qw( /usr/local/rrdtool-1.0.33/lib/perl ../lib/perl );
use RRDs;

@ARGV=split(' ',$ARGV[0]); # This line needed when run as a cgi script
                           # Comment it out when running from the command line			   
$Na=0;
# Do my own Getops processing
foreach $Arg(@ARGV) {
#  print "<p>$Na $Arg</p>\n";
  if ($Arg =~/^-/) {
   $Arg = substr $Arg,1;
   if ((!defined $ARGV[($Na+1)]) || $ARGV[($Na+1)]=~/^-/) {
#      print "$Na !defined $ARGV[($Na+1)]) | $ARGV[($Na+1)] =~/^-/\n";
      $Arga{$Arg}=0; }
   else {
   $Arga{$Arg}=$ARGV[($Na+1)];
   }
  }
$Na++;
}

if (defined $Arga{'future'}) {
  $Multiplier=-1; 
  }
  else {
  $Multiplier=1;
  }

$t=time+120;
#$t=time+86400*7;

# Make default a day
$TP="day";
  if ($Arga{'day'}==0) {
    $tfirst=$t-86400;
    $tlast=$t; }
  else {
    $tlast=$t-$Arga{'day'}*86400*$Multiplier;
    $tfirst=$tlast - 86400 ; 
  }
 
if (defined $Arga{'hour'}) { 
  $TP="hour";
  if ($Arga{'hour'}==0) {
    $tlast=$t;
    $tfirst=$t-7200; }
  else {
    $tlast=$t-3600*$Arga{'hour'}*$Multiplier;
    $tfirst=$tlast-7200 ; 
  }
}

if (defined $Arga{'week'}) { 
  $TP="week";
  if ($Arga{'week'}==0) {
    $tlast=$t;
    $tfirst=$t-86400*7; }
  else {
    $tlast=$t-7*86400*$Arga{'week'}*$Multiplier;
    $tfirst=$tlast-86400*7 ; 
  }
}

if (defined $Arga{'month'}) { 
  $TP="month";
  if ($Arga{'month'}==0) {
    $tlast=$t;
    $tfirst=$t-86400*28;     
  }
  else {
     $tlast=$t-28*86400*$Arga{'month'}*$Multiplier;
    $tfirst=$tlast-86400*28;
  }
}

if (defined $Arga{'year'}) { 
  $TP="year";
  $tlast=$t;
  $tfirst=$t-366*86400;
}



# start from topitall directory
chdir  "../../tia";
my @Files=<*.rrd>;
chomp @Files;
$host=(split('\.',$Files[0]))[0];
$deltat=$tlast-$tfirst;

print <<EOF
Content-type: text/html


<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" content="text/html; charset=iso-8859-1">
<META HTTP-EQUIV="expires" content="0">
<META HTTP-EQUIV="pragma" content="no-cache">
<META NAME="DESCRIPTION" CONTENT="Topitall Host">
<TITLE>Topitall Host $host</TITLE>


<h2>Topitall : $host : $TP</h2>
<br>
<A href=/tiaImages/profiler.html>Go to this page in a couple of minutes when the gif 
files have been created. </A>
<br>
<table BORDER CELLSPACING=0 HEIGHT="20" BGCOLOR="#FFCC55" >
<tr>
<td><A HREF=\"/tia/profiler.cgi?%20-hour\">Hour</A></td>
<td><A HREF=\"/tia/profiler.cgi?%20-day\">Day</A></td>
<td><A HREF=\"/tia/profiler.cgi?%20-week\">Week</A></td>
<td><A HREF=\"/tia/profiler.cgi?%20-month\">Month</A></td>
<td><A HREF=\"/tia/profiler.cgi?%20-year\">Year</A></td>
</tr>
</table>
<br>
$deltat $tlast $tfirst

</body>\n</html>
EOF
;


open (HFH,"> ../server/images/profiler.html");
print HFH <<EOF

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" content="text/html; charset=iso-8859-1">
<META HTTP-EQUIV="expires" content="0">
<META HTTP-EQUIV="pragma" content="no-cache">
<META NAME="DESCRIPTION" CONTENT="Topitall Host">
<TITLE>Topitall Host $host</TITLE>
<h2>Topitall : $host : $TP</h2>
<br>
<table BORDER CELLSPACING=0 HEIGHT="20" BGCOLOR="#FFCC55" >
<tr>
<td><A HREF=\"/tia/profiler.cgi?%20-hour\">Hour</A></td>
<td><A HREF=\"/tia/profiler.cgi?%20-day\">Day</A></td>
<td><A HREF=\"/tia/profiler.cgi?%20-week\">Week</A></td>
<td><A HREF=\"/tia/profiler.cgi?%20-month\">Month</A></td>
<td><A HREF=\"/tia/profiler.cgi?%20-year\">Year</A></td>
</tr>
</table>

EOF
;


$Rpath='tia';
$NButton=-1;
foreach $F (@Files) {
#  print "$F\n";
  ($host,$Cat1,$Cat2,$Cat3)=split('\.',$F);
  if ($Cat3 eq "rrd") { $Category="$Cat1-$Cat2" ;}
  else { $Category=$Cat1 ; }
  print  HFH "<br><img SRC=\"/tiaImages/$Category.gif\">\n";
}
print HFH "</body>\n</html>\n";
close HFH;

foreach $F (@Files) {
#  print "$F\n";
  ($host,$Cat1,$Cat2,$Cat3)=split('\.',$F);
  if ($Cat3 eq "rrd") { $Category="$Cat1-$Cat2" ;}
  else { $Category=$Cat1 ; }
  $Title="$Category : $TP";
  $IFname="$F";
  $OFname="../server/images/$Category.gif";
  RRDs::graph "$OFname",
    "--title", "$Title",
    "--start", "$tfirst",
    "--end", "$tlast",
    "--imgformat","GIF",
   "--width=640",
   "COMMENT:Topitall / J Belshaw                  ",
#    "--height=200",
    "DEF:a=$IFname:Val:AVERAGE",
    "LINE2:a#00b674:$Val\\c";
  if ($ERROR = RRDs::error) {
  print STDERR "ERROR: $ERROR\n";
  }
}
